package io;

import static org.junit.Assert.*;

import java.util.Arrays;
import java.util.Set;

import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Ignore;
import org.junit.Test;

public class BigDataSortTest {
	static String fileName = "bigdata.txt";
	static Integer[] source1 = null;
	static Integer[] source2 = null;

	// @Ignore("该方法只有当要向文件写入数据时才要用到")
	@Test
	public void testWrite() {
		int amount = 1000000; // 1E6
		int upLimit = 100000000;// 1E8
		BigDataSort.writeHugeAmoutInt(fileName, amount, upLimit);

	}

	@Test
	public void initializeRead() {
		// @Before标注：任何测试方法执行前都要执行的代码段
		// @BeforeClass标注：测试用例初始化的时候，只执行一次
		// @Test当做一个不同的待测试方法进行测试，这样可以统计该步骤所需时间
		Set<Integer> intSet = BigDataSort
				.readHugeAmoutIntUsingBufferReader(fileName);
		source1 = intSet.toArray(new Integer[0]);
		source2 = source1.clone();

		System.out.println("Read done!");
	}

	@Ignore("使用该方法读取文件，速度太慢")
	@Test
	public void testReadUsingScanner() {

		Set<Integer> intSet = BigDataSort.readHugeAmoutInt(fileName);
		Integer[] result = null;
		result = intSet.toArray(new Integer[0]);
	}

	@Test
	public void testReadUsingBufferReaderBitSort() {

		BigDataSort.bitSetSort(source1, source1.length);
		System.out.println("BitSort Done!");
	}

	@Test(timeout = 6000)
	public void testReadUsingBufferReaderArraysSort() {
		// 使用@Test(timeout = 6000)标明，如果该方法执行时间大于6s，则代表失败
		Arrays.sort(source2);
		System.out.println("Arrays.sort Done!");
	}

}
